Halide 22.0.0 Halide compiler and libraries

Public Member Functions | Protected Types | Protected Member Functions | List of all members
Halide::Internal::GeneratorOutput_Func< T > Class Template Reference

`#include <Generator.h>`

Inheritance diagram for Halide::Internal::GeneratorOutput_Func< T >:

## Public Member Functions
template<typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
GeneratorOutput_Func< T > & | operator= (const Func &f)
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
Func & | operator[] (size_t i)
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
const Func & | operator[] (size_t i) const
GeneratorOutput_Func< T > & | set_estimate (const Var &var, const Expr &min, const Expr &extent)
GeneratorOutput_Func< T > & | set_estimates (const Region &estimates)
Public Member Functions inherited from Halide::Internal::GeneratorOutputImpl< T >
template<typename... Args, typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
FuncRef | operator() (Args &&...args) const
template<typename ExprOrVar , typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
FuncRef | operator() (std::vector< ExprOrVar > args) const
template<typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
| operator Func () const
template<typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>
| operator Stage () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
size_t | size () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
const ValueType & | operator[] (size_t i) const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
const ValueType & | at (size_t i) const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
std::vector< ValueType >::const_iterator | begin () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>
std::vector< ValueType >::const_iterator | end () const
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&std::extent_v< T2, 0 >==0 > * = nullptr>
void | resize (size_t size)
Public Member Functions inherited from Halide::Internal::GeneratorOutputBase
void | set_type (const std::vector< Type > &types)
| Set types dynamically for tuple outputs. More...
| ~GeneratorOutputBase () override
void | set_type (const Type &type)
| Forward schedule-related methods to the underlying Func. More...
Public Member Functions inherited from Halide::Internal::GIOBase
virtual | ~GIOBase ()=default
void | set_type (const Type &type)
void | set_dimensions (int dims)
void | set_array_size (int size)
| GIOBase (const GIOBase &)=delete
GIOBase & | operator= (const GIOBase &)=delete
| GIOBase (GIOBase &&)=delete
GIOBase & | operator= (GIOBase &&)=delete

## Protected Types
using | TBase = typename Super::TBase
Protected Types inherited from Halide::Internal::GeneratorOutputImpl< T >
using | TBase = std::remove_all_extents_t< T >
using | ValueType = Func

## Protected Member Functions
| GeneratorOutput_Func (const std::string &name)
| GeneratorOutput_Func (const std::string &name, const std::vector< Type > &t, int d)
| GeneratorOutput_Func (const std::string &name, const std::vector< Type > &t)
| GeneratorOutput_Func (const std::string &name, int d)
| GeneratorOutput_Func (size_t array_size, const std::string &name, const std::vector< Type > &t, int d)
Protected Member Functions inherited from Halide::Internal::GeneratorOutputImpl< T >
bool | is_array () const override
template<typename T2 = T, std::enable_if_t< !std::is_array_v< T2 > > * = nullptr>
| GeneratorOutputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&(std::extent_v< T2, 0 > > 0)> * = nullptr>
| GeneratorOutputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > &&std::rank_v< T2 >==1 &&std::extent_v< T2, 0 >==0 > * = nullptr>
| GeneratorOutputImpl (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
Protected Member Functions inherited from Halide::Internal::GeneratorOutputBase
template<typename T2 , std::enable_if_t< std::is_same_v< T2, Func > > * = nullptr>
HALIDE_NO_USER_CODE_INLINE T2 | as () const
| GeneratorOutputBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
| GeneratorOutputBase (const std::string &name, ArgInfoKind kind, const std::vector< Type > &t, int d)
void | init_internals ()
void | resize (size_t size)
virtual std::string | get_c_type () const
void | check_value_writable () const override
const char * | input_or_output () const override
Protected Member Functions inherited from Halide::Internal::GIOBase
bool | array_size_defined () const
size_t | array_size () const
virtual bool | is_array () const
const std::string & | name () const
ArgInfoKind | kind () const
bool | gio_types_defined () const
const std::vector< Type > & | gio_types () const
Type | gio_type () const
bool | dims_defined () const
int | dims () const
const std::vector< Func > & | funcs () const
const std::vector< Expr > & | exprs () const
| GIOBase (size_t array_size, const std::string &name, ArgInfoKind kind, const std::vector< Type > &types, int dims)
std::string | array_name (size_t i) const
virtual void | verify_internals ()
void | check_matching_array_size (size_t size) const
void | check_matching_types (const std::vector< Type > &t) const
void | check_matching_dims (int d) const
template<typename ElemType >
const std::vector< ElemType > & | get_values () const
void | check_gio_access () const
virtual void | check_value_writable () const =0
virtual const char * | input_or_output () const =0
template<>
const std::vector< Expr > & | get_values () const
template<>
const std::vector< Func > & | get_values () const

## Additional Inherited Members
Protected Attributes inherited from Halide::Internal::GIOBase
int | array_size_
const std::string | name_
const ArgInfoKind | kind_
std::vector< Type > | types_
int | dims_
std::vector< Func > | funcs_
std::vector< Expr > | exprs_
GeneratorBase * | generator {nullptr}

## Detailed Description

template<typename T>
class Halide::Internal::GeneratorOutput_Func< T >

Definition at line 2695 of file Generator.h.

## Member Typedef Documentation

## ◆ TBase

template<typename T >

using Halide::Internal::GeneratorOutput_Func< T >::TBase = typename Super::TBase
| protected

Definition at line 2705 of file Generator.h.

## Constructor & Destructor Documentation

## ◆ GeneratorOutput_Func() [1/5]

template<typename T >

Halide::Internal::GeneratorOutput_Func< T >::GeneratorOutput_Func | ( | const std::string & | name | ) |
| inline explicit protected

Definition at line 2707 of file Generator.h.

## ◆ GeneratorOutput_Func() [2/5]

template<typename T >

Halide::Internal::GeneratorOutput_Func< T >::GeneratorOutput_Func | ( | const std::string & | name,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| inline protected

Definition at line 2711 of file Generator.h.

## ◆ GeneratorOutput_Func() [3/5]

template<typename T >

Halide::Internal::GeneratorOutput_Func< T >::GeneratorOutput_Func | ( | const std::string & | name,
|  | const std::vector< Type > & | t
| ) |  |
| inline protected

Definition at line 2715 of file Generator.h.

## ◆ GeneratorOutput_Func() [4/5]

template<typename T >

Halide::Internal::GeneratorOutput_Func< T >::GeneratorOutput_Func | ( | const std::string & | name,
|  | int | d
| ) |  |
| inline protected

Definition at line 2719 of file Generator.h.

## ◆ GeneratorOutput_Func() [5/5]

template<typename T >

Halide::Internal::GeneratorOutput_Func< T >::GeneratorOutput_Func | ( | size_t | array_size,
|  | const std::string & | name,
|  | const std::vector< Type > & | t,
|  | int | d
| ) |  |
| inline protected

Definition at line 2723 of file Generator.h.

## Member Function Documentation

## ◆ operator=()

template<typename T >
template<typename T2 = T, std::enable_if_t<!std::is_array_v< T2 > > * = nullptr>

GeneratorOutput_Func< T > & Halide::Internal::GeneratorOutput_Func< T >::operator= | ( | const Func & | f | ) |
| inline

Definition at line 2730 of file Generator.h.

## ◆ operator[]() [1/2]

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

Func & Halide::Internal::GeneratorOutput_Func< T >::operator[] | ( | size_t | i | ) |
| inline

Definition at line 2742 of file Generator.h.

## ◆ operator[]() [2/2]

template<typename T >
template<typename T2 = T, std::enable_if_t< std::is_array_v< T2 > > * = nullptr>

const Func & Halide::Internal::GeneratorOutput_Func< T >::operator[] | ( | size_t | i | ) | const
| inline

Definition at line 2750 of file Generator.h.

## ◆ set_estimate()

template<typename T >

GeneratorOutput_Func< T > & Halide::Internal::GeneratorOutput_Func< T >::set_estimate | ( | const Var & | var,
|  | const Expr & | min,
|  | const Expr & | extent
| ) |  |
| inline

Definition at line 2755 of file Generator.h.

References internal_assert, and Halide::Internal::min().

## ◆ set_estimates()

template<typename T >

GeneratorOutput_Func< T > & Halide::Internal::GeneratorOutput_Func< T >::set_estimates | ( | const Region & | estimates | ) |
| inline

Definition at line 2764 of file Generator.h.

References internal_assert.

The documentation for this class was generated from the following file:

- src/Generator.h